      program FMCHDFB
C     Version 1
C
c     Based on FXCHANGE, written by Dale Keefe and Yoram Apelblat
c     of the University of Alberta in 1992 
c     SPC format added and name changed to FMTCHNG by JEB and YA, 
C     April 1997.
C     Modified to FMCH77 for FORTRAN 77 compatibility by JEB in 1977
C     and to FMCH77 version 4 by John Bertie August 2001.
C     FMCHDF version 1 by John Bertie September 2001.
C     FMCHDF version 2 by John Bertie, November 2001
C	FMCHDF version 3 by John Bertie, November 2001
C     FMCHDFB version 1 is an extensive modification of FMCHDF version 3
C     by John Bertie in June 2003 to provide a version that is suitable
C     for use as a batch file.  The input is solely from file and the 
C     program is called by the command line statement 
C     FMCH32B <inputfilename (>outputfilename),
C     where the >outputfilename is optional

C     FMCHDFB uses BSPCRW.FOR and reads/writes both types of SPC file


	PARAMETER(NMAX=18750)
	character*12 inspectrum,outspectrum
	character*130 memo
	real*4 x(NMAX),y(NMAX),xsp,xep
	integer*4 npts
	COMMON/FOR_READ/NPTLIMIT

	NPTLIMIT=NMAX
	write(*,900)
	write(*,950)NPTLIMIT
  	write(*,955)NPTLIMIT
  	write(*,*)' The program does not yet handle type 4 (JCAMP) input f
     1iles'
	write(*,*)
    
      read(*,*)nrun
C
      do 500 k=1,nrun
       read(*,*,END=30)inspectrum,n1,outspectrum,n2
       if(n2.eq.5) read(*,'(a)',END=30)memo
       if(n2.eq.6) read(*,'(a)',END=30)memo
c      
c     Read input file and 
c     create an XY format, regardless of later usage of X values

   30  if(n1.eq.1) then
       call read1(inspectrum,x,y,xsp,xep,npts,NPTLIMIT)
       elseif(n1.eq.2) then
       call read2(inspectrum,x,y,xsp,xep,npts,NPTLIMIT)
       elseif(n1.eq.3) then 
       call read3(inspectrum,x,y,xsp,xep,npts,NPTLIMIT)
       elseif(n1.eq.4) then
       write(*,*) ' option not available'
       goto 500
       elseif(n1.eq.5) then 
       call read5(inspectrum,x,y,xsp,xep,npts)
       elseif(n1.eq.6)then
       call read5(inspectrum,x,y,xsp,xep,npts)
       endif
C	The distinction between reading old or new SPC files is made in
C	READSC which is called by read5

C   Do not write output if the spectral file is too large.
C   This is only relevant for file types 5 and 6.
C   The program only reads up to NPTLIMIT points from file types 1,2 & 3
       IF(NPTS.GT.NPTLIMIT) THEN
          write(*,920)inspectrum,NPTLIMIT
          GO TO 500
       ENDIF
       Write(*,925)inspectrum

c     write output file in desired format
      if(n2.eq.1) then
       call write1(outspectrum,y,xsp,xep,npts)
	elseif(n2.eq.2) then
	 call write2(outspectrum,x,y,npts)
      elseif(n2.eq.3) then 
	 call write3(outspectrum,x,y,npts)
	elseif(n2.eq.4) then
	 write(*,*) ' option not available'
	 goto 500
      elseif(n2.eq.5) then 
       call write5(outspectrum,x,y,npts,memo)
       elseif(n2.eq.6) then 
       call write6(outspectrum,x,y,npts,memo)
      endif
      Write(*,930)outspectrum
  500 continue
 
C
  550 stop 'Program ends normally'
  
  900 FORMAT(' Input or output file formats are: ',/, 
     #' 1= Y  (single column)',/,
     #' 2= XY (two columns)',/, 
     #' 3= 6XY (6 columns)',/, 
     #' 4= JCAMP ',/,
     #' 5= OLD SPC',/,
     #' 6= New SPC'/)
  910 Format('   Number of Data Points = ',I6,/,'   Highest wavenumber
     x = ',F10.2,' cm-1',/,'   lowest wavenumber = ',F10.2,' cm-1')

  920 FORMAT(' FMCHDF:File ',A12,':Number of Points exceeds array size'
     1 1X,I5,/,' No output created',/)
  925 FORMAT(' File ',A12,' read')
  930 FORMAT(' File ',A12,' written',/)
  935 FORMAT(' File',A12,' can not be opened; enter new file name')
  950 FORMAT(/,'  Type 5 and 6 input files are limited to',I6,
     1' points.',/,'  No output is produced from larger files',/)
  955 FORMAT('  Only the first',I6,' points are processed from input',/,
     1'  files of types 1, 2 and 3.',/)
      end
      
      subroutine read1(FILNAM,x,y,xsp,xep,npts,NPTLIMIT)
	CHARACTER*12 FILNAM
      REAL*4 x(1),y(1),xsp,xep,xnpts,space
      integer*4 npts
	INTEGER*2 ICHANR
C   *** OPEN THE FILE
      CALL GETCHAN(ICHANR,IER)
      OPEN(UNIT=ICHANR,FILE=Filnam,STATUS='OLD',ACTION='READ')
      read(ICHANR,*)xsp
      read(ICHANR,*)xep
      read(ICHANR,*)xnpts
      npts=int(xnpts)
	space=(xsp-xep)/(npts-1)
	IF(npts.GT.NPTLIMIT) THEN
	   npts=NPTLIMIT
	   xep=xsp-(NPTLIMIT-1)*space
	ENDIF
      do 10 I=1,npts
      read(ICHANR,*)y(I)
      x(I)=xsp-(I-1)*space
   10 continue
      CALL PUTCHAN(ICHANR,IER)
      return
      end

      subroutine read2(FILNAM,x,y,xsp,xep,npts,NPTLIMIT)
	CHARACTER*12 FILNAM
      REAL*4 x(1),y(1),xsp,xep
      integer*4 npts,icount
	INTEGER*2 ICHANR
C   *** OPEN THE FILE
      CALL GETCHAN(ICHANR,IER)
      OPEN(UNIT=ICHANR,FILE=Filnam,STATUS='OLD',ACTION='READ')
      icount=0
      do 10 i=1,NPTLIMIT
      read(ICHANR,*,end=999)x(i),y(i)
   10 icount=icount+1
  999 npts=icount
      xsp=x(1)
      xep=x(npts)
      CALL PUTCHAN(ICHANR,IER)
      return
      end

      subroutine read3(FILNAM,x,y,xsp,xep,npts,NPTLIMIT)
      CHARACTER*12 FILNAM
      REAL*4 x(1),y(1),xsp,xep
      integer*4 npts,icount
      INTEGER*2 ICHANR
!   *** OPEN THE FILE
      CALL GETCHAN(ICHANR,IER)
      OPEN(UNIT=ICHANR,FILE=Filnam,STATUS='OLD',ACTION='READ')
      icount=0
      MAXDO=NPTLIMIT/3
      do 10 i=1,MAXDO
      	 k=(i-1)*3+1
      	 read(ICHANR,*,end=999)x(k),y(k),x(k+1),y(k+1),x(k+2),y(k+2)
      	 icount=icount+3
   10 continue
      continue
      WRITE(*,900)FILNAM,MAXDO
  900 FORMAT('   File ',A12,': ',I6,' lines read & converted but'
     1,' end of input file not reached')
      i=1
      GO TO 997
  999 i=1
  998 if(x(icount+i).eq.0) goto 997
      i=i+1
      go to 998
  997 icount=icount+i-1
      npts=icount
      xsp=x(1)
      xep=x(npts)
      CALL PUTCHAN(ICHANR,IER)
      return
      end
     
      subroutine read5(inspectrum,x,y,xsp,xep,npts)
      REAL*4 x(1),y(1),xsp,xep,res
      INTEGER*1 xt,yt
      integer*4 npts,ier
      character*12 inspectrum 
      character*130 memo
      COMMON/FOR_READ/NPTLIMIT
c       xt, yt, res, memo, ier are not used by FMCH for input files.
C
      CALL READSC(inspectrum,y,npts,xsp,xep,xt,yt,res,memo,ier)
C   Check that the spectral file is not too large.

      IF(NPTS.GT.NPTLIMIT) THEN
	   GO TO 999
      ENDIF

      space=(xsp-xep)/(npts-1)
      do 2, J=1,npts
	     x(J)=xsp-(J-1)*space
    2 continue
C   Check to see the accuracy of the calculated x values
      XDIF=X(npts)-XEP
      WRITE(*,*)' Routine READ5: Check of x accuracy'
      WRITE(*,*)' Calculated last X minus read XEP = ',XDIF
  999	return
      end

      subroutine write1(outfil,y,xsp,xep,npts)
      REAL*4 y(1),xsp,xep
      integer*4 npts
      INTEGER*2 ICHANW
      CHARACTER*12 OUTFIL
!   OPEN THE FILE
	CALL GETCHAN(ICHANW,IER)
      OPEN(UNIT=ICHANW,FILE=Outfil,STATUS='REPLACE',ACTION='WRITE')
      write(ICHANW,'(f9.3)')xsp
      write(ICHANW,'(f9.3)')xep
      write(ICHANW,'(i5)')npts
      do 10 i=1,npts
   10 write(ICHANW,100)y(i)
  100 format(1x,e14.7)
      CALL PUTCHAN(ICHANW,IER)
      return
      end

      subroutine write2(outfil,x,y,npts)
      REAL*4 x(1),y(1)
      integer*4 npts
      INTEGER*2 ICHANW
      CHARACTER*12 OUTFIL
! **** OPEN THE FILE
      CALL GETCHAN(ICHANW,IER)
      OPEN(UNIT=ICHANW,FILE=Outfil,STATUS='REPLACE',ACTION='WRITE')
      do 10 i=1,npts
   10 write(ICHANW,100)x(i),y(i)
  100 format(f11.5,2x,e14.7)
      CALL PUTCHAN(ICHANW,IER)
      return
      end

      subroutine write3(outfil,x,y,npts)
      REAL*4 x(1),y(1)
      integer*4 npts,nlines,nptfin
      INTEGER*2 ICHANW
      CHARACTER*12 OUTFIL
!  ****open the file	
	CALL GETCHAN(ICHANW,IER)
      OPEN(UNIT=ICHANW,FILE=Outfil,STATUS='REPLACE',ACTION='WRITE')

c     calculate no. of lines (nlines).
      nlines=npts/3   
      if(nlines*3.ne.npts) nlines=nlines+1
c 
c     calculate no. of pts. in last line (nptfin)
      nptfin=npts-(nlines-1)*3
      do 10 j=1,nlines-1
      k=(j-1)*3+1
      write(ICHANW,103)x(k),y(k),x(k+1),y(k+1),x(k+2),y(k+2)
   10 continue
      k=(nlines-1)*3+1
      if(nptfin.eq.3) write(ICHANW,103)x(k),y(k),x(k+1),y(k+1),x(k+2),
     &y(k+2)
      if(nptfin.eq.2) write(ICHANW,102)x(k),y(k),x(k+1),y(k+1)
      if(nptfin.eq.1) write(ICHANW,101)x(k),y(k)
      CALL PUTCHAN(ICHANW,IER)
  103 format(3(f9.3,1x,e14.7,10x))
  102 format(2(f9.3,1x,e14.7,10x))
  101 format(f9.3,1x,e14.7)
      return
      end

      subroutine write5(outspectrum,x,y,npts,memo)
C   Writes the original SPECTRACALC type of SPC file

      REAL*4 x(1),y(1),xsp,xep,res
      INTEGER*1 xt,yt,fversn
      INTEGER*4 npts
      CHARACTER*12 outspectrum
      CHARACTER*130 memo

      COMMON/SPCtype/fversn
      fversn=77
      res=0
	xsp=x(1)
	xep=x(npts)
C    Set xt=1 (wavenumber abcissa) yt=0 (arbitrary ordinate)
      xt=1
      yt=0
      call WRITESC(outspectrum,y,npts,xsp,xep,xt,yt,res,memo,ier)
      return
      end

      subroutine write6(outspectrum,x,y,npts,memo)
C    Writes the 1997 Universal data format type of SPC file

      REAL*4 x(1),y(1),xsp,xep,res
      INTEGER*1 xt,yt,fversn
      integer*4 npts
      CHARACTER*1 New
      CHARACTER*12 outspectrum
      CHARACTER*130 memo
	
	COMMON/SPCtype/fversn
	COMMON/Original/New
	fversn=75
	New='Y'
	res=0
	  xsp=x(1)
	  xep=x(npts)
C    Set xt=1 (wavenumber abcissa) yt=0 (arbitrary ordinate)
      xt=1
      yt=0
      call WRITESC(outspectrum,y,npts,xsp,xep,xt,yt,res,memo,ier)
      return
      end
